.\"	$NetBSD: dh.4,v 1.13 2003/08/07 10:31:10 agc Exp $
.\"
.\" Copyright (c) 1980, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     from: @(#)dh.4	8.1 (Berkeley) 6/5/93
.\"
.Dd June 5, 1993
.Dt DH 4 vax
.Os
.Sh NAME
.Nm dh
.Nd
.Tn DH-11 Ns / Ns Tn DM-11
serial multiplexer device interface
.Sh SYNOPSIS
.Cd "dh0 at uba0 csr 0160020 vector dhrint dhxint" Op Ar flags
.Cd "dm0 at uba0 csr 0170500 vector dmintr" Op Ar flags
.Sh DESCRIPTION
NOTE: This driver has not been ported from
.Bx 4.4
yet.
.Pp
A
.Tn DH-11
provides 16 serial communication lines;
.Tn DM-11 Ns s
may optionally be
paired with
.Tn DH-11 Ns s
to provide modem control for the lines.
.Pp
An optional argument
.Ar flags
may be supplied with the device specification
in the
.Xr config 1
file indicating
that the line corresponding to
bit number
.Ar i
is not properly
connected, and should be treated as hard-wired with carrier
always present.  Thus specifying
.Ql flags 0x0004
for
.Li dh0
would cause line
.Pa ttyh2
to be treated in this way.
.Pp
Normal I/O
control parameters for individual lines are managed by
.Xr ioctl 2
calls.
Line speeds may be initiated via
.Xr getty 8
and
.Xr stty 1
or may be communicated by other programs which
use
.Xr ioctl 2
such as
.Xr ifconfig 8 ,
see
.Xr tty 4  .
.Pp
The
.Nm dh
driver monitors the rate of input on each board,
and switches between the use of character-at-a-time interrupts
and input silos.
While the silo is enabled during periods of high-speed input,
the driver polls for input 30 times per second.
.Sh FILES
.Bl -tag -width /dev/tty[h-o][0-9a-f]x -compact
.It Pa /dev/tty[h-o][0-9a-f]
.It Pa /dev/ttyd[0-9a-f]
.El
.Sh DIAGNOSTICS
.Bl -diag
.It dh%d: NXM.
No response from
.Tn UNIBUS
on a DMA transfer
within a timeout period.  This is often followed by a
.Tn UNIBUS
adapter
error.  This occurs most frequently when the
.Tn UNIBUS
is heavily loaded
and when devices which hog the bus (such as
.Tn RK07 Ns s )
are present.
It is not serious.
.Pp
.It dh%d: silo overflow.
The character input silo overflowed
before it could be serviced.  This can happen if a hard error occurs
when the
.Tn CPU
is running with elevated priority, as the system will
then print a message on the console with interrupts disabled.
It is not serious.
.El
.Sh SEE ALSO
.Xr tty 4
.Sh HISTORY
A
.Nm
driver appeared in
.At v6 .
